diff --git a/docs/Makefile.am b/docs/Makefile.am
index 1b4353b..f4ce9ce 100644
--- a/docs/Makefile.am
+++ b/docs/Makefile.am
@@ -70,8 +70,6 @@ devhelpxsl = devhelp/devhelp.xsl devhelp/html.xsl
 
 png = \
   32favicon.png \
-  footer_corner.png \
-  footer_pattern.png \
   libvirt-header-bg.png \
   libvirt-header-logo.png \
   libvirtLogo.png \
@@ -81,7 +79,6 @@ png = \
   libvirt-driver-arch.png \
   libvirt-object-model.png \
   madeWith.png \
-  et.png \
   migration-managed-direct.png \
   migration-managed-p2p.png \
   migration-native.png \
diff --git a/docs/et.png b/docs/et.png
deleted file mode 100644
index 115f8a140d74ee72e8d2c847d2bc43bddfb829a5..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/docs/footer_corner.png b/docs/footer_corner.png
deleted file mode 100644
index 090bfce9f86913fc494e5dcdd31eb03ee74fac39..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/docs/footer_pattern.png b/docs/footer_pattern.png
deleted file mode 100644
index 647c52a375b6a54ef21639bae67bf299fcf5a1ad..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/docs/generic.css b/docs/generic.css
index ce022cd..de9f968 100644
--- a/docs/generic.css
+++ b/docs/generic.css
@@ -37,10 +37,6 @@ h1,h2,h3,h4,h5,h6 {
   margin-top: 0.5em;
 }
 
-div.footer {
-  margin-top: 1em;
-}
-
 h1 {
   font-size: 2em;
 }
diff --git a/docs/libvirt.css b/docs/libvirt.css
index b42c9de..17ecbb4 100644
--- a/docs/libvirt.css
+++ b/docs/libvirt.css
@@ -243,36 +243,6 @@ p.image {
     background: #c5dbd8;
 }
 
-#footer {
-    clear: both;
-    position: relative;
-    margin: 0px;
-    padding: 0px;
-    border: 0px;
-    width: 100%;
-    height: 180px;
-    background: #FFFFFF;
-/*    background: #757575; */
-}
-/* This is hidden from IE <= 6 because it can't do transparency */
-/* body > #footer {
-    background: #757575 url(footer_pattern.png) repeat-x;
-} */
-
-#footer p {
-    position: absolute;
-    top: 0px;
-    left: 0px;
-    margin: 0px;
-    border: 0px solid red;
-    width: 220px;
-    text-align: center;
-}
-
-#footer p a img {
-    border: 0px;
-}
-
 #projects {
     margin: 0px;
     border: 0px;
@@ -291,10 +261,6 @@ p.image {
     top: 0px;
     left: 0px;
 }
-/* This is hidden from IE <= 6 because it can't do transparency */
-head:first-child+body #projects dl {
-    background: url(footer_corner.png) no-repeat ! important;
-}
 
 #projects #p1 {
     margin-left: 25%;
diff --git a/docs/page.xsl b/docs/page.xsl
index 80164dd..cd98f7d 100644
--- a/docs/page.xsl
+++ b/docs/page.xsl
@@ -163,12 +163,6 @@
             <xsl:apply-templates select="/html:html/html:body/*" mode="content"/>
           </div>
         </div>
-        <div id="footer">
-          <p id="sponsor">
-	    Sponsored by:<br/>
-            <a href="http://et.redhat.com/"><img src="{$href_base}et.png" alt="Project sponsored by Red Hat Emerging Technology"/></a>
-          </p>
-        </div>
       </body>
     </html>
   </xsl:template>